SystemOrganization addCategory: #'GT-Tests-Debugger'!

TestCase subclass: #GTDebuggerSmokeTest
	instanceVariableNames: 'session window debugger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Debugger'!

GTDebuggerSmokeTest subclass: #GTBytecodeDebuggerSmokeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Debugger'!

!GTBytecodeDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/28/2015 20:43'!
contextToTest

	^ [ 20 factorial ] asContext! !

!GTBytecodeDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/28/2015 20:41'!
debuggerToTest

	^ GTBytecodeDebugger! !

!GTBytecodeDebuggerSmokeTest methodsFor: 'utils' stamp: 'AndreiChis 12/28/2015 20:48'!
stepToDebuggerEntryPointIn: aProcess
	"The bytecode debugger can handle any context."! !

!GTDebuggerSmokeTest class methodsFor: 'testing' stamp: 'AndreiChis 12/17/2013 10:00'!
isAbstract
	^ self name = #GTDebuggerSmokeTest! !

!GTDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/28/2015 20:44'!
contextToTest
	self subclassResponsibility! !

!GTDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 19:17'!
debuggerToTest
	self subclassResponsability! !

!GTDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/28/2015 20:45'!
instantiateSession
	| context process |
	context := self contextToTest.

	process := Process 
		forContext: context
		priority: Processor userInterruptPriority.
	
	self stepToDebuggerEntryPointIn: process.
	^ self debuggerToTest spanNewSessionLabeled:  'test session' forContext: process suspendedContext fromProcess: process! !

!GTDebuggerSmokeTest methodsFor: 'running' stamp: 'AndreiChis 12/17/2013 15:14'!
setUp
	session := self instantiateSession.
	debugger := self debuggerToTest new.! !

!GTDebuggerSmokeTest methodsFor: 'utils' stamp: 'AndreiChis 12/28/2015 20:48'!
stepToDebuggerEntryPointIn: aProcess
	"Step into the execution until a context is reached 
	that can be handled by the debugger under test."
	
	^ self subclassResponsibility! !

!GTDebuggerSmokeTest methodsFor: 'running' stamp: 'AndreiChis 8/18/2015 11:01'!
tearDown 
	debugger ifNotNil: [ debugger close].
	window := nil.! !

!GTDebuggerSmokeTest methodsFor: 'tests' stamp: 'AndreiChis 12/17/2013 15:44'!
testDebugger

	self assert: (debugger class handlesContext: session interruptedContext). 

	window := debugger openOn: session.
	
	self assert: window model equals: debugger.
	self assert: debugger session interruptedContext notNil.
	self assert: debugger session interruptedProcess notNil.
	
 	debugger close.

	self assert: window model equals: nil.
	self assert: debugger session interruptedContext equals: nil.
	self assert: debugger session interruptedProcess equals: nil.! !

GTDebuggerSmokeTest subclass: #GTGenericStackDebuggerSmokeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Debugger'!

!GTGenericStackDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/28/2015 20:43'!
contextToTest

	^ [ 20 factorial ] asContext! !

!GTGenericStackDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 11:24'!
debuggerToTest

	^ GTGenericStackDebugger! !

!GTGenericStackDebuggerSmokeTest methodsFor: 'utils' stamp: 'AndreiChis 12/28/2015 20:50'!
stepToDebuggerEntryPointIn: aProcess
	"The generic debugger can handle any context."! !

GTDebuggerSmokeTest subclass: #GTSUnitDebuggerSmokeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Debugger'!

!GTSUnitDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/28/2015 20:15'!
contextToTest

	^ [ GTSUnitExampleFailingTest new testArrays ] asContext! !

!GTSUnitDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/28/2015 20:56'!
debuggerToTest

	^ GTSUnitDebugger! !

!GTSUnitDebuggerSmokeTest methodsFor: 'utils' stamp: 'AndreiChis 12/28/2015 20:13'!
stepToDebuggerEntryPointIn: aProcess

	aProcess
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;	
		step;
		completeStep: aProcess suspendedContext; 
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step
		! !

TestCase subclass: #GTGenericStackDebuggerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tests-Debugger'!

!GTGenericStackDebuggerTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/8/2016 16:08'!
testBasic
	| context process debugger printedString |
	context := [ 20 factorial ] asContext.
	process := Process
		forContext: context
		priority: Processor userInterruptPriority.
	debugger := GTGenericStackDebugger on: (process newDebugSessionNamed: 'test debugging' startedAt: context).
	self assert: debugger stackPresentation selection equals: context.
	printedString := '[ 20 factorial ] in GTGenericStackDebuggerTest>>testBasic'.
	self assert: debugger selectedContext printString equals: printedString.
	debugger send.
	debugger send.
	debugger update.
	self
		assert: debugger codePresentation entity sourceCode equals: (Integer >> #factorial) sourceCode.
	self
		assert:
			debugger stackPresentation selection printString
		equals: 'SmallInteger(Integer)>>factorial'.
	process terminate! !
